def stern_brocot_path(numerator, denominator):
    """
    Находит путь к дроби в дереве Штерна-Броко.

    Args:
        numerator: Числитель дроби.
        denominator: Знаменатель дроби.

    Returns:
        Строка, представляющая путь к дроби (L и R), или "no", если дробь недостижима.
    """
    if denominator == 0 or numerator < 0 or denominator < 0:
        return "no"  # Недопустимая дробь

    if numerator == 0 and denominator == 1:
        return ""

    path = ""
    a, b = 0, 1
    c, d = 1, 0

    while True:
        mediant_num = a + c
        mediant_den = b + d

        if numerator * mediant_den < denominator * mediant_num:  # Лево
            path += "L"
            c = mediant_num  #Исправлено: обновление c и d
            d = mediant_den
        elif numerator * mediant_den > denominator * mediant_num:  # Право
            path += "R"
            a = mediant_num #Исправлено: обновление a и b
            b = mediant_den
        else:
            return path  # Найдена дробь

        if a == numerator and b == denominator:
            return path
        if c == numerator and d == denominator:
            return path
a, b = (map(int, input().split()))
# Примеры использования:

print('R'+stern_brocot_path(a,b))
