import heapq

def solve():
    n, m, k = map(int, input().split())
    ps = []
    for _ in range(m):
        u, v = map(int, input().split())
        ps.append((u, v))
        ps.append((v, u))

    g = []
    for _ in range(k):
        p, h = map(int, input().split())
        g.append((p, h))

    adj = {i: [] for i in range(1, n + 1)}
    for u, v in ps:
        adj[u].append(v)

    def dijkstra(start, max_dist):
        s = {node: float('inf') for node in adj}
        s[start] = 0
        q = [(0, start)]

        while q:
            dist, current = heapq.heappop(q)
            if dist > max_dist:
                continue
            if dist > s[current]:
                continue

            for neighbor in adj[current]:
                if s[neighbor] > s[current] + 1:
                    s[neighbor] = s[current] + 1
                    heapq.heappush(q, (s[neighbor], neighbor))

        reachable = [node for node, dist in s.items() if dist <= max_dist]
        return reachable

    pr = set()
    for gp, gr in g:
        pr.update(dijkstra(gp, gr))

    pr = sorted(list(pr))

    print(len(pr))
    if pr:
        print(*pr)

solve()