import math

def distance(p1, p2):
    return math.sqrt((p1[0] - p2[0])**2 + (p1[1] - p2[1])**2)

def solve_greedy(points):
    num_points = len(points)
    if num_points < 2:
        return 0

    unvisited = set(range(num_points))
    current_point = 0
    total_distance = 0
    path = [current_point]
    unvisited.remove(current_point)

    while unvisited:
        nearest_point = -1
        min_dist_to_nearest = float('inf')
        for i in unvisited:
            dist = distance(points[current_point], points[i])
            if dist < min_dist_to_nearest:
                min_dist_to_nearest = dist
                nearest_point = i
        total_distance += min_dist_to_nearest
        path.append(nearest_point)
        unvisited.remove(nearest_point)
        current_point = nearest_point

    total_distance += distance(points[path[-1]], points[path[0]])  # Возвращение в начальную точку

    return total_distance


# Пример



n = int(input())
far = []
for sd in range(n):
    a, b = map(int, input().split())
    far.append((a, b))

print(solve_greedy(far))